//+------------------------------------------------------------------+
//|                              Momentum Reversal Detector (MRD)  |
//|                                               |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "GJ"

#property indicator_separate_window 

#property indicator_level1    185   //
#property indicator_level2    -185  
//#property indicator_level3    0
#property indicator_levelcolor   Black
#property indicator_levelstyle   STYLE_DOT

#property indicator_buffers 5 
#property indicator_color1    DimGray
#property indicator_color2    Blue
#property indicator_color3    Gold
#property indicator_color4    Red
#property indicator_color5    Black
#property indicator_style1    STYLE_SOLID
#property indicator_style2    STYLE_SOLID
#property indicator_style3    STYLE_SOLID
#property indicator_style4    STYLE_SOLID
#property indicator_style5    STYLE_SOLID
#property indicator_width1    5
#property indicator_width2    5
#property indicator_width3    5
#property indicator_width4    5
#property indicator_width5    5

//---- input parameters
extern int       Momentum_Period=34;
extern int       num_bars=1000;

extern string    Momentum__equals_Indi_Levels="**Comment**";
extern int       momentum=125;

extern string    Color_of_Background="**Comment**";
extern string    when_higher_TF_is_positive="**Comment**";
extern bool      Show_Different_Background=TRUE;
extern color     Positive_Background_Color=PaleGreen;

extern string    Use_this_to_show_Blue_Histos="**Comment**";
extern string    when_Momentum_is_not_reached="**Comment**";
extern bool      Always_Show_Price_Divergence=True;

extern string    When_higher_TF_has_Price_Div="**Comment**";
extern bool      Show_Divergence_Background=TRUE;
extern color     UP_Divergence_Color=Magenta;
extern color     DOWN_Divergence_Color=Lime;


// parameters
int i=0;  
bool initDo=true;
int bar=0; int prevbars=0; int startpar=0;
int cs=0; int prevcs=0; int frame=0;
string commodt="nothing";

string Indi_Name;

bool expired=false;
double now, prev, now_high, prev_high, now_low, prev_low;
double Max_CCI=0, Max_High = 0, Max_Low = 0;

int TF2;  // 
double CCI_TF2_now; double CCI_TF2_prev;
double now_TF2_high, prev_TF2_high, now_TF2_low, prev_TF2_low ;
double Max_TF2_CCI=0, Max_TF2_High = 0, Max_TF2_Low = 0;

bool New_Rect = FALSE;
datetime Start_Rect_Time;  // 
datetime End_Rect_Time;    // 
bool New_Div_Rect=False; 
datetime Start_Div_Rect_Time, End_Div_Rect_Time;


//---- buffers
double HistoGray[];     // 
double HistoBlue[];     // 
double HistoOrange[];
double HistoRed[];
double HistoBlack[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   // Indicator Name showed
   Indi_Name = "Momentum Reversal";
   IndicatorShortName(Indi_Name);
   
   // HAH    
      
//---- CCI Histo Colours
   SetIndexStyle(0,DRAW_HISTOGRAM,indicator_style1,indicator_width1,indicator_color1);
   SetIndexBuffer(0,HistoGray);
   
   SetIndexStyle(1,DRAW_HISTOGRAM,indicator_style2,indicator_width2,indicator_color2);
   SetIndexBuffer(1,HistoBlue);
   
   SetIndexStyle(2,DRAW_HISTOGRAM,indicator_style3,indicator_width3,indicator_color3);
   SetIndexBuffer(2,HistoOrange);
   
   SetIndexStyle(3,DRAW_HISTOGRAM,indicator_style4,indicator_width4,indicator_color4);
   SetIndexBuffer(3,HistoRed);
   
   SetIndexStyle(4,DRAW_HISTOGRAM,indicator_style5,indicator_width5,indicator_color5);
   SetIndexBuffer(4,HistoBlack);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  /*
  int a=0;
  while ( a < ObjectsTotal(OBJ_RECTANGLE) ) 
        {
        string name = ObjectName(a);
        if ( StringFind(name, Indi_Name, 0) != -1 ) ObjectDelete(name);
        a++;
        }
   */      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   
   //if (expired) return (0); 
    
   // CHECK
   int counted_bars=IndicatorCounted();

   cs = Momentum_Period + num_bars; //checksum used to see if parameters have been changed

   if ((cs==prevcs) && (commodt == Symbol()) && 
      (frame == (Time[4] - Time[5])) &&
      ((Bars - prevbars) < 2))
      startpar = Bars - prevbars; 
   else 
      startpar = -1;  //params haven't changed only need to calculate new bar

   commodt = Symbol();
   frame = Time[4] - Time[5];
   prevbars = Bars;
   prevcs = cs;

   if (startpar == 1 || startpar == 0)  
      bar = startpar;
   else 
      initDo = true;   
   // END CHECK: if check OK, BAR = 0, cycle "FOR" only of the last bar


   // In case of first tick or checksum error
   // initialize buffers and do all the "NumBars" in "FOR" cycle 
   if (initDo) 
      {
      HistoGray[num_bars-1]=0;
      HistoBlue[num_bars-1]=0;
      HistoOrange[num_bars-1]=0;
      HistoRed[num_bars-1]=0;
      bar=num_bars-2;
      initDo=false;
      
      int window=WindowFind(Indi_Name);           // 
      ObjectsDeleteAll(window,OBJ_RECTANGLE);     // 
      }
       
          
   // Core Function Start (FOR)
   for (i = bar; i >= 0; i--) 
   {   
      // all the buffers to zero to avoid
      // overlap of histos (last histo erased)
      HistoGray[i] = EMPTY_VALUE;
      HistoBlue[i] = EMPTY_VALUE;
      HistoOrange[i] = EMPTY_VALUE;
      HistoRed[i] = EMPTY_VALUE;
      HistoBlack[i] = EMPTY_VALUE;
      
      bool change_of_sign = FALSE;
      
      now = iCCI(NULL,0,Momentum_Period,PRICE_TYPICAL,i);
      prev = iCCI(NULL,0,Momentum_Period,PRICE_TYPICAL,i+1);
      now_high = iHigh(NULL,0,i);
      prev_high = iHigh(NULL,0,i+1);
      now_low = iLow(NULL,0,i);
      prev_low = iLow(NULL,0,i+1);
      
      //change of sign => Max_CCI and Max_Price to zero (first CCI Red)
      if ((prev >= 0 && now < 0) || (prev <= 0 && now > 0)) 
          {Max_CCI = 0; change_of_sign = TRUE;
          Max_High = 0; Max_Low = 123456789;} 
      
      // Update Max at end of bar -- 
      //
      if ( MathAbs(prev)>MathAbs(Max_CCI) ) Max_CCI = prev; 
      if (now >=0) {if (prev_high > Max_High) Max_High = prev_high;}
      if (now <=0) {if (prev_low < Max_Low) Max_Low = prev_low;}
               
      // Colour it!      
      if (now >= momentum)
         {
         if ( now>prev && now>=Max_CCI ) HistoRed[i] = now;  //
         if ( now<Max_CCI && now_high>=Max_High ) HistoBlue[i] = now; // **Divergence !!**
         if ( now_high<Max_High ) HistoOrange[i] = now;
         if (change_of_sign) HistoBlack[i] = momentum;  // HisoBlack 
         }                                              // 

      if (now <= -momentum)
         {
         if ( now<prev && now<=Max_CCI ) HistoRed[i] = now;
         if ( now>Max_CCI && now_low<=Max_Low ) HistoBlue[i] = now; // **Divergence !!**
         if ( now_low>Max_Low ) HistoOrange[i] = now;
         if (change_of_sign) HistoBlack[i] = -momentum;
         }
      
      if (now > -momentum && now < momentum) 
         {
         if (change_of_sign) HistoBlack[i] = now; 
            else 
               {
               HistoGray[i] = now;
               if (Always_Show_Price_Divergence)
                  {
                  if ( now>0 && now<Max_CCI && now_high>=Max_High ) HistoBlue[i] = now; // **Divergence !!**
                  if ( now<0 && now>Max_CCI && now_low<=Max_Low ) HistoBlue[i] = now; // **Divergence !!**
                  }
               }
         }
      
   
   //**************** 
   //**************** 
   //**************** 
   //**************** 
   
   if (Show_Different_Background || Show_Divergence_Background)
      {
      
      int TF = Period (); //
      
      // mi sposto su TF+1
      int TimeFrame_Array[] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
      int a=0;
      while (a<=8)
            { 
            if (TF==TimeFrame_Array[a]) TF2=TimeFrame_Array[a+1];  
            a++;
            }
            
      // mi sposto su TF+1   
      
      int shift = TF2*60; // shift in secondi per End_Rect
      int shift_actual = TF*60;  //
   
      CCI_TF2_now = iCCI(NULL,TF2,Momentum_Period,PRICE_TYPICAL,i);
      CCI_TF2_prev = iCCI(NULL,TF2,Momentum_Period,PRICE_TYPICAL,i+1);
      now_TF2_high = iHigh(NULL,TF2,i);
      prev_TF2_high = iHigh(NULL,TF2,i+1);
      now_TF2_low = iLow(NULL,TF2,i);
      prev_TF2_low = iLow(NULL,TF2,i+1);
      
      bool change_of_sign_TF2 = False;
      bool Divergence_UP = False; bool Divergence_DOWN = False;
      
      //change of sign => Max_CCI and Max_Price to zero (first CCI Red)
      if ((CCI_TF2_prev >= 0 && CCI_TF2_now < 0) || (CCI_TF2_prev <= 0 && CCI_TF2_now > 0)) 
          {Max_TF2_CCI = 0; change_of_sign_TF2 = TRUE;
          Max_TF2_High = 0; Max_TF2_Low = 123456789;} 
      
      // Update Max at end of bar -- 
      //e 
      if ( MathAbs(CCI_TF2_prev)>MathAbs(Max_TF2_CCI) ) Max_TF2_CCI = CCI_TF2_prev; 
      if (CCI_TF2_now >=0) {if (prev_TF2_high > Max_TF2_High) Max_TF2_High = prev_TF2_high;}
      if (CCI_TF2_now <=0) {if (prev_TF2_low < Max_TF2_Low) Max_TF2_Low = prev_TF2_low;}
      
      // Find Blue Histos on TF2
      if (CCI_TF2_now>0 && CCI_TF2_now<Max_TF2_CCI && now_TF2_high>=Max_TF2_High) Divergence_UP = True; 
      // **Divergence !!**  indipendente dal Momentum !!
      if (CCI_TF2_now<0 && CCI_TF2_now>Max_TF2_CCI && now_TF2_low<=Max_TF2_Low) Divergence_DOWN = True;
      
      
      // *****   *******
      
      if (i!=0 && Show_Different_Background)  // 
         {                                    
         if (CCI_TF2_now>0 && CCI_TF2_prev<=0)  //CCI TF2 diventa positivo
             { New_Rect=TRUE; Start_Rect_Time=iTime(NULL,TF2,i); End_Rect_Time=iTime(NULL,TF2,i)+shift; Draw_Rect();} 
                                //  
                                // 
         if (New_Rect && CCI_TF2_now>0) { End_Rect_Time= iTime(NULL,TF2,i)+shift; Move_Rect(); }
         if (CCI_TF2_now<=0) New_Rect = FALSE; 
         }
       
      if (i==0 && Show_Different_Background)  //
         {      
         if (New_Rect && CCI_TF2_now>0) { End_Rect_Time=iTime(NULL,TF,i)+shift_actual; Move_Rect(); } //CCI TF2 gi positivo
         if (!New_Rect && CCI_TF2_now>0 && CCI_TF2_prev<=0)  //CCI TF2 diventa positivo
             { New_Rect = TRUE; Start_Rect_Time=iTime(NULL,TF,i); End_Rect_Time=iTime(NULL,TF,i)+shift_actual; Draw_Rect();} 
         if (CCI_TF2_now<=0) New_Rect = FALSE;
         }
         
      if (i!=0 && Show_Divergence_Background)   
         {
         if ( New_Div_Rect && (Divergence_UP || Divergence_DOWN) )
             { End_Div_Rect_Time= iTime(NULL,TF2,i)+shift; Move_Div_Rect(); }
         if (!New_Div_Rect && (Divergence_UP || Divergence_DOWN))  //Divergenza su TF2 
             { New_Div_Rect=TRUE; Start_Div_Rect_Time=iTime(NULL,TF2,i); 
               End_Div_Rect_Time=iTime(NULL,TF2,i)+shift; Draw_Div_Rect(Divergence_UP,Divergence_DOWN);}
         if ( (!Divergence_UP) && (!Divergence_DOWN) ) New_Div_Rect = FALSE;
         // 
         }
      
      if (i==0 && Show_Divergence_Background)  
         {      
         if ( New_Div_Rect && (Divergence_UP || Divergence_DOWN) )
             { End_Div_Rect_Time= iTime(NULL,TF,i)+shift_actual; Move_Div_Rect(); }
         if (!New_Div_Rect && (Divergence_UP || Divergence_DOWN))  //Divergenza su TF2 
             { New_Div_Rect=TRUE; Start_Div_Rect_Time=iTime(NULL,TF,i); 
               End_Div_Rect_Time=iTime(NULL,TF,i)+shift_actual; Draw_Div_Rect(Divergence_UP,Divergence_DOWN);}
         if ( (!Divergence_UP) && (!Divergence_DOWN) ) New_Div_Rect = FALSE; 
         }
      
      
      } //END IF Show_Different_Background  OR  Show_Divergence_Background
   
   
   } // END FOR
   return(0);
  }  // END START
  
  
  
//********* FUNZIONI **************

void Draw_Rect()
     {
     string Start_Rect_String = TimeToStr (Start_Rect_Time); 
     string name = Indi_Name+" "+Start_Rect_String;
     int window=WindowFind(Indi_Name); 
     ObjectCreate(name, OBJ_RECTANGLE, window, Start_Rect_Time, 1000, End_Rect_Time, -1000);
     ObjectSet(name, OBJPROP_COLOR, Positive_Background_Color);
     ObjectSet(name, OBJPROP_BACK, TRUE);
     }
     
void Move_Rect()
     {
     string Start_Rect_String = TimeToStr (Start_Rect_Time); 
     string name = Indi_Name+" "+Start_Rect_String;
     ObjectMove(name, 1, End_Rect_Time, -1000);  // 
     }

void Draw_Div_Rect(bool Div_UP, bool Div_DOWN)
     {
     string Start_Div_Rect_String = TimeToStr (Start_Div_Rect_Time); 
     string name = Indi_Name+" DIV "+Start_Div_Rect_String;
     int window=WindowFind(Indi_Name); 
     ObjectCreate(name, OBJ_RECTANGLE, window, Start_Div_Rect_Time, 1000, End_Div_Rect_Time, -1000);
     if (Div_UP) ObjectSet(name, OBJPROP_COLOR, UP_Divergence_Color);
     if (Div_DOWN) ObjectSet(name, OBJPROP_COLOR, DOWN_Divergence_Color);
     ObjectSet(name, OBJPROP_BACK, TRUE);
     }

void Move_Div_Rect()
     {
     string Start_Div_Rect_String = TimeToStr (Start_Div_Rect_Time); 
     string name = Indi_Name+" DIV "+Start_Div_Rect_String;
     ObjectMove(name, 1, End_Div_Rect_Time, -1000);  //  
     }     
     
     